Package com.saxonica.xqj.pull

## Class PullTracer

- java.lang.Object
- - net.sf.saxon.pull.PullFilter
  - - com.saxonica.xqj.pull.PullTracer

- All Implemented Interfaces:
    `PullProvider`

      public class PullTracer
      extends PullFilter

  PullTracer is a PullFilter that can be inserted into a pull pipeline for diagnostic purposes. It traces all the events as they are read, writing details to System.err

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.pull.PullProvider

      `PullProvider.Event`

  - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.pull.PullFilter

      `currentEvent`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `PullTracer​(PullProvider base)` | Create a PullTracer

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `PullProvider.Event` | `next()` | Get the next event.

    - ### Methods inherited from class net.sf.saxon.pull.PullFilter

      `close, current, getAtomicValue, getAttributes, getNamePool, getNamespaceDeclarations, getNodeName, getPipelineConfiguration, getSchemaType, getSourceLocator, getStringValue, getUnderlyingProvider, getUnparsedEntities, setPipelineConfiguration, skipToMatchingEnd`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### PullTracer

          public PullTracer​(PullProvider base)

      Create a PullTracer
      Parameters:
        `base` - the PullProvider to which requests are to be passed

  - ### Method Detail

    - #### next

          public PullProvider.Event next()
                                  throws XPathException

      Get the next event. This implementation gets the next event from the underlying PullProvider, copies it to the branch Receiver, and then returns the event to the caller.
      Specified by:
        `next` in interface `PullProvider`
      Overrides:
        `next` in class `PullFilter`
      Returns:
        an integer code indicating the type of event. The code `PullProvider.Event.END_OF_INPUT` is returned at the end of the sequence.
      Throws:
        `XPathException` - if a dynamic error occurs